/*
 * -----------------------------------------------------------------------
 *
 * NOTE: Do *not* edit this file; instead, edit 'erl_alloc.types' and
 *       build again! This file was automatically generated by
 *       'make_alloc_types' on Thu Mar 27 11:55:33 2008.
 *
 * -----------------------------------------------------------------------
 *
 * ``The contents of this file are subject to the Erlang Public License,
 * Version 1.1, (the "License"); you may not use this file except in
 * compliance with the License. You should have received a copy of the
 * Erlang Public License along with this software. If not, it can be
 * retrieved via the world wide web at http://www.erlang.org/.
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Original Code is Ericsson Utvecklings AB.
 * Portions created by Ericsson are Copyright 1999, Ericsson Utvecklings
 * AB. All Rights Reserved.''
 */

#ifndef ERL_ALLOC_TYPES_H__
#define ERL_ALLOC_TYPES_H__


/* --- Allocator numbers -------------------------------------------------- */

#define ERTS_ALC_A_INVALID (0)

#define ERTS_ALC_A_MIN (1)

#define ERTS_ALC_A_SYSTEM (1)
#define ERTS_ALC_A_TEMPORARY (2)
#define ERTS_ALC_A_SHORT_LIVED (3)
#define ERTS_ALC_A_STANDARD (4)
#define ERTS_ALC_A_LONG_LIVED (5)
#define ERTS_ALC_A_EHEAP (6)
#define ERTS_ALC_A_ETS (7)
#define ERTS_ALC_A_FIXED_SIZE (8)
#define ERTS_ALC_A_BINARY (9)
#define ERTS_ALC_A_DRIVER (10)

#define ERTS_ALC_A_MAX (10)


/* --- Class numbers ------------------------------------------------------ */

#define ERTS_ALC_C_INVALID (0)

#define ERTS_ALC_C_MIN (1)

#define ERTS_ALC_C_PROCESSES  (1)
#define ERTS_ALC_C_ETS  (2)
#define ERTS_ALC_C_BINARIES  (3)
#define ERTS_ALC_C_ATOM  (4)
#define ERTS_ALC_C_SYSTEM  (5)
#define ERTS_ALC_C_CODE  (6)

#define ERTS_ALC_C_MAX (6)


/* --- Type number intervals ---------------------------------------------- */

#define ERTS_ALC_N_INVALID (0)

#define ERTS_ALC_N_MIN (1)

/* Type numbers used for sys_alloc */
#define ERTS_ALC_N_MIN_A_SYSTEM (1)
#define ERTS_ALC_N_MAX_A_SYSTEM (13)

/* Type numbers used for temp_alloc */
#define ERTS_ALC_N_MIN_A_TEMPORARY (14)
#define ERTS_ALC_N_MAX_A_TEMPORARY (29)

/* Type numbers used for sl_alloc */
#define ERTS_ALC_N_MIN_A_SHORT_LIVED (30)
#define ERTS_ALC_N_MAX_A_SHORT_LIVED (41)

/* Type numbers used for std_alloc */
#define ERTS_ALC_N_MIN_A_STANDARD (42)
#define ERTS_ALC_N_MAX_A_STANDARD (69)

/* Type numbers used for ll_alloc */
#define ERTS_ALC_N_MIN_A_LONG_LIVED (70)
#define ERTS_ALC_N_MAX_A_LONG_LIVED (92)

/* Type numbers used for eheap_alloc */
#define ERTS_ALC_N_MIN_A_EHEAP (93)
#define ERTS_ALC_N_MAX_A_EHEAP (95)

/* Type numbers used for ets_alloc */
#define ERTS_ALC_N_MIN_A_ETS (96)
#define ERTS_ALC_N_MAX_A_ETS (103)

/* Type numbers used for fix_alloc */
#define ERTS_ALC_N_MIN_A_FIXED_SIZE (104)
#define ERTS_ALC_N_MAX_A_FIXED_SIZE (115)

/* Type numbers used for binary_alloc */
#define ERTS_ALC_N_MIN_A_BINARY (116)
#define ERTS_ALC_N_MAX_A_BINARY (117)

/* Type numbers used for driver_alloc */
#define ERTS_ALC_N_MIN_A_DRIVER (118)
#define ERTS_ALC_N_MAX_A_DRIVER (118)

#define ERTS_ALC_N_MAX (118)


/* --- Multi thread use of allocators -------------------------------------- */

#define ERTS_ALC_MTA_SYSTEM (1)
#define ERTS_ALC_MTA_TEMPORARY (0)
#define ERTS_ALC_MTA_SHORT_LIVED (0)
#define ERTS_ALC_MTA_STANDARD (0)
#define ERTS_ALC_MTA_LONG_LIVED (0)
#define ERTS_ALC_MTA_EHEAP (0)
#define ERTS_ALC_MTA_ETS (0)
#define ERTS_ALC_MTA_FIXED_SIZE (0)
#define ERTS_ALC_MTA_BINARY (1)
#define ERTS_ALC_MTA_DRIVER (1)


/* --- Types --------------------------------------------------------------- */

typedef Uint32 ErtsAlcType_t; /* The type used for memory types */

#define ERTS_ALC_T_INVALID (0)

#define ERTS_ALC_T_UNDEF (209)
#define ERTS_ALC_T_NBIF_TABLE (337)
#define ERTS_ALC_T_ASYNC (465)
#define ERTS_ALC_T_INFO_DSBUF (593)
#define ERTS_ALC_T_DRV_THR_OPTS (721)
#define ERTS_ALC_T_DRV_TID (849)
#define ERTS_ALC_T_DRV_MTX (977)
#define ERTS_ALC_T_DRV_CND (1105)
#define ERTS_ALC_T_DRV_RWLCK (1233)
#define ERTS_ALC_T_DRV_TSD (1361)
#define ERTS_ALC_T_ETHR_INTERNAL (1489)
#define ERTS_ALC_T_ENVIRONMENT (1617)
#define ERTS_ALC_T_PUTENV_STR (1745)
#define ERTS_ALC_T_MSG_ROOTS (1810)
#define ERTS_ALC_T_ROOTSET (1938)
#define ERTS_ALC_T_LOADER_TMP (2146)
#define ERTS_ALC_T_NC_TMP (2258)
#define ERTS_ALC_T_TMP (2386)
#define ERTS_ALC_T_DCTRL_BUF (2514)
#define ERTS_ALC_T_TMP_DIST_BUF (2642)
#define ERTS_ALC_T_ESTACK (2770)
#define ERTS_ALC_T_PORT_CALL_BUF (2898)
#define ERTS_ALC_T_DB_TMP (2978)
#define ERTS_ALC_T_DB_MC_STK (3106)
#define ERTS_ALC_T_DB_MS_CMPL_HEAP (3234)
#define ERTS_ALC_T_LOGGER_DSBUF (3410)
#define ERTS_ALC_T_TMP_DSBUF (3538)
#define ERTS_ALC_T_DDLL_TMP_BUF (3666)
#define ERTS_ALC_T_SYS_READ_BUF (3794)
#define ERTS_ALC_T_PEND_SUSPEND (3859)
#define ERTS_ALC_T_MSG_REF (3987)
#define ERTS_ALC_T_SL_BIF_TIMER (4115)
#define ERTS_ALC_T_DB_FIXATION (4259)
#define ERTS_ALC_T_DB_FIX_DEL (4387)
#define ERTS_ALC_T_DB_MS_RUN_HEAP (4515)
#define ERTS_ALC_T_PORT_TASK (4691)
#define ERTS_ALC_T_PORT_TASKQ (4819)
#define ERTS_ALC_T_MISC_OP_LIST (4947)
#define ERTS_ALC_T_PORT_NAMES (5075)
#define ERTS_ALC_T_FD_LIST (5203)
#define ERTS_ALC_T_POLLSET_UPDREQ (5331)
#define ERTS_ALC_T_LINK_LH (5396)
#define ERTS_ALC_T_MONITOR_LH (5524)
#define ERTS_ALC_T_NLINK_LH (5652)
#define ERTS_ALC_T_SUSPEND_MON (5780)
#define ERTS_ALC_T_LL_BIF_TIMER (5908)
#define ERTS_ALC_T_REG_TABLE (6100)
#define ERTS_ALC_T_FUN_TABLE (6244)
#define ERTS_ALC_T_DIST_TABLE (6356)
#define ERTS_ALC_T_NODE_TABLE (6484)
#define ERTS_ALC_T_MODULE_REFS (6628)
#define ERTS_ALC_T_DCACHE (6740)
#define ERTS_ALC_T_DIST_ENTRY (6868)
#define ERTS_ALC_T_NODE_ENTRY (6996)
#define ERTS_ALC_T_DRV_ENTRY_LIST (7124)
#define ERTS_ALC_T_ARG_REG (7188)
#define ERTS_ALC_T_PROC_DICT (7316)
#define ERTS_ALC_T_CALLS_BUF (7444)
#define ERTS_ALC_T_BPD (7636)
#define ERTS_ALC_T_PORT_NAME (7764)
#define ERTS_ALC_T_LINEBUF (7892)
#define ERTS_ALC_T_IOQ (8020)
#define ERTS_ALC_T_BITS_BUF (8148)
#define ERTS_ALC_T_DDLL_PROCESS (8276)
#define ERTS_ALC_T_DDLL_HANDLE (8404)
#define ERTS_ALC_T_PORT_DATA_LOCK (8532)
#define ERTS_ALC_T_NODES_MON (8596)
#define ERTS_ALC_T_FD_ENTRY_BUF (8788)
#define ERTS_ALC_T_PRT_REP_EXIT (8916)
#define ERTS_ALC_T_ATOM_TXT (9029)
#define ERTS_ALC_T_BIF_TIMER_TABLE (9173)
#define ERTS_ALC_T_ATOM_TABLE (9285)
#define ERTS_ALC_T_EXPORT_TABLE (9445)
#define ERTS_ALC_T_MODULE_TABLE (9573)
#define ERTS_ALC_T_PROC_TABLE (9621)
#define ERTS_ALC_T_PORT_TABLE (9813)
#define ERTS_ALC_T_TIMER_WHEEL (9941)
#define ERTS_ALC_T_CODE (10085)
#define ERTS_ALC_T_ASYNC_Q (10197)
#define ERTS_ALC_T_DB_TABLES (10277)
#define ERTS_ALC_T_DB_MS_PSDO_PROC (10405)
#define ERTS_ALC_T_INSTR_INFO (10581)
#define ERTS_ALC_T_SCHDLR_DATA (10645)
#define ERTS_ALC_T_DDLL_ERRCODES (10837)
#define ERTS_ALC_T_DRV_TAB (10965)
#define ERTS_ALC_T_DRV_EV_STATE (11093)
#define ERTS_ALC_T_POLLSET (11221)
#define ERTS_ALC_T_POLL_FDS (11349)
#define ERTS_ALC_T_POLL_RES_EVS (11477)
#define ERTS_ALC_T_FD_STATUS (11605)
#define ERTS_ALC_T_FD_TAB (11733)
#define ERTS_ALC_T_CS_PROG_PATH (11861)
#define ERTS_ALC_T_HEAP (11926)
#define ERTS_ALC_T_OLD_HEAP (12054)
#define ERTS_ALC_T_HEAP_FRAG (12182)
#define ERTS_ALC_T_DB_SEG (12327)
#define ERTS_ALC_T_DB_SEG_TAB (12455)
#define ERTS_ALC_T_DB_STK (12583)
#define ERTS_ALC_T_DB_TRANS_TAB (12711)
#define ERTS_ALC_T_DB_SEL_LIST (12839)
#define ERTS_ALC_T_DB_DMC_ERROR (12967)
#define ERTS_ALC_T_DB_DMC_ERR_INFO (13095)
#define ERTS_ALC_T_DB_TERM (13223)
#define ERTS_ALC_T_PROC (13336)
#define ERTS_ALC_T_ATOM (13512)
#define ERTS_ALC_T_EXPORT (13672)
#define ERTS_ALC_T_MODULE (13800)
#define ERTS_ALC_T_REG_PROC (13848)
#define ERTS_ALC_T_MONITOR_SH (13976)
#define ERTS_ALC_T_NLINK_SH (14104)
#define ERTS_ALC_T_PROC_LIST (14232)
#define ERTS_ALC_T_FUN_ENTRY (14440)
#define ERTS_ALC_T_DB_TABLE (14504)
#define ERTS_ALC_T_DRV_EV_D_STATE (14680)
#define ERTS_ALC_T_DRV_SEL_D_STATE (14808)
#define ERTS_ALC_T_DRV_BINARY (14905)
#define ERTS_ALC_T_BINARY (15033)
#define ERTS_ALC_T_DRV (15194)


/* --- Field sizes, masks, and shifts -------------------------------------- */

#define ERTS_ALC_A_BITS (4)
#define ERTS_ALC_C_BITS (3)
#define ERTS_ALC_N_BITS (7)
#define ERTS_ALC_T_BITS (14)

#define ERTS_ALC_A_MASK (15)
#define ERTS_ALC_C_MASK (7)
#define ERTS_ALC_N_MASK (127)
#define ERTS_ALC_T_MASK (16383)

#define ERTS_ALC_A_SHIFT (0)
#define ERTS_ALC_C_SHIFT (4)
#define ERTS_ALC_N_SHIFT (7)


/* --- Mappings ------------------------------------------------------------ */

/* type -> type number */
#define ERTS_ALC_T2N(T) (((T) >> ERTS_ALC_N_SHIFT) & ERTS_ALC_N_MASK)

/* type -> allocator number */
#define ERTS_ALC_T2A(T) (((T) >> ERTS_ALC_A_SHIFT) & ERTS_ALC_A_MASK)

/* type -> class number */
#define ERTS_ALC_T2C(T) (((T) >> ERTS_ALC_C_SHIFT) & ERTS_ALC_C_MASK)

/* type number -> type */
#define ERTS_ALC_N2T(N) (erts_alc_n2t[(N)])

/* type number -> type description */
#define ERTS_ALC_N2TD(N) (erts_alc_n2td[(N)])

/* type -> type description */
#define ERTS_ALC_T2TD(T) (ERTS_ALC_N2TD(ERTS_ALC_T2N((T))))

/* class number -> class description */
#define ERTS_ALC_C2CD(C) (erts_alc_c2cd[(C)])

/* allocator number -> allocator description */
#define ERTS_ALC_A2AD(A) (erts_alc_a2ad[(A)])

extern const ErtsAlcType_t erts_alc_n2t[];
extern const char *erts_alc_n2td[];
extern const char *erts_alc_c2cd[];
extern const char *erts_alc_a2ad[];

#ifdef ERTS_ALC_INTERNAL__

const ErtsAlcType_t erts_alc_n2t[] = {
  ERTS_ALC_T_INVALID,
  ERTS_ALC_T_UNDEF,
  ERTS_ALC_T_NBIF_TABLE,
  ERTS_ALC_T_ASYNC,
  ERTS_ALC_T_INFO_DSBUF,
  ERTS_ALC_T_DRV_THR_OPTS,
  ERTS_ALC_T_DRV_TID,
  ERTS_ALC_T_DRV_MTX,
  ERTS_ALC_T_DRV_CND,
  ERTS_ALC_T_DRV_RWLCK,
  ERTS_ALC_T_DRV_TSD,
  ERTS_ALC_T_ETHR_INTERNAL,
  ERTS_ALC_T_ENVIRONMENT,
  ERTS_ALC_T_PUTENV_STR,
  ERTS_ALC_T_MSG_ROOTS,
  ERTS_ALC_T_ROOTSET,
  ERTS_ALC_T_LOADER_TMP,
  ERTS_ALC_T_NC_TMP,
  ERTS_ALC_T_TMP,
  ERTS_ALC_T_DCTRL_BUF,
  ERTS_ALC_T_TMP_DIST_BUF,
  ERTS_ALC_T_ESTACK,
  ERTS_ALC_T_PORT_CALL_BUF,
  ERTS_ALC_T_DB_TMP,
  ERTS_ALC_T_DB_MC_STK,
  ERTS_ALC_T_DB_MS_CMPL_HEAP,
  ERTS_ALC_T_LOGGER_DSBUF,
  ERTS_ALC_T_TMP_DSBUF,
  ERTS_ALC_T_DDLL_TMP_BUF,
  ERTS_ALC_T_SYS_READ_BUF,
  ERTS_ALC_T_PEND_SUSPEND,
  ERTS_ALC_T_MSG_REF,
  ERTS_ALC_T_SL_BIF_TIMER,
  ERTS_ALC_T_DB_FIXATION,
  ERTS_ALC_T_DB_FIX_DEL,
  ERTS_ALC_T_DB_MS_RUN_HEAP,
  ERTS_ALC_T_PORT_TASK,
  ERTS_ALC_T_PORT_TASKQ,
  ERTS_ALC_T_MISC_OP_LIST,
  ERTS_ALC_T_PORT_NAMES,
  ERTS_ALC_T_FD_LIST,
  ERTS_ALC_T_POLLSET_UPDREQ,
  ERTS_ALC_T_LINK_LH,
  ERTS_ALC_T_MONITOR_LH,
  ERTS_ALC_T_NLINK_LH,
  ERTS_ALC_T_SUSPEND_MON,
  ERTS_ALC_T_LL_BIF_TIMER,
  ERTS_ALC_T_REG_TABLE,
  ERTS_ALC_T_FUN_TABLE,
  ERTS_ALC_T_DIST_TABLE,
  ERTS_ALC_T_NODE_TABLE,
  ERTS_ALC_T_MODULE_REFS,
  ERTS_ALC_T_DCACHE,
  ERTS_ALC_T_DIST_ENTRY,
  ERTS_ALC_T_NODE_ENTRY,
  ERTS_ALC_T_DRV_ENTRY_LIST,
  ERTS_ALC_T_ARG_REG,
  ERTS_ALC_T_PROC_DICT,
  ERTS_ALC_T_CALLS_BUF,
  ERTS_ALC_T_BPD,
  ERTS_ALC_T_PORT_NAME,
  ERTS_ALC_T_LINEBUF,
  ERTS_ALC_T_IOQ,
  ERTS_ALC_T_BITS_BUF,
  ERTS_ALC_T_DDLL_PROCESS,
  ERTS_ALC_T_DDLL_HANDLE,
  ERTS_ALC_T_PORT_DATA_LOCK,
  ERTS_ALC_T_NODES_MON,
  ERTS_ALC_T_FD_ENTRY_BUF,
  ERTS_ALC_T_PRT_REP_EXIT,
  ERTS_ALC_T_ATOM_TXT,
  ERTS_ALC_T_BIF_TIMER_TABLE,
  ERTS_ALC_T_ATOM_TABLE,
  ERTS_ALC_T_EXPORT_TABLE,
  ERTS_ALC_T_MODULE_TABLE,
  ERTS_ALC_T_PROC_TABLE,
  ERTS_ALC_T_PORT_TABLE,
  ERTS_ALC_T_TIMER_WHEEL,
  ERTS_ALC_T_CODE,
  ERTS_ALC_T_ASYNC_Q,
  ERTS_ALC_T_DB_TABLES,
  ERTS_ALC_T_DB_MS_PSDO_PROC,
  ERTS_ALC_T_INSTR_INFO,
  ERTS_ALC_T_SCHDLR_DATA,
  ERTS_ALC_T_DDLL_ERRCODES,
  ERTS_ALC_T_DRV_TAB,
  ERTS_ALC_T_DRV_EV_STATE,
  ERTS_ALC_T_POLLSET,
  ERTS_ALC_T_POLL_FDS,
  ERTS_ALC_T_POLL_RES_EVS,
  ERTS_ALC_T_FD_STATUS,
  ERTS_ALC_T_FD_TAB,
  ERTS_ALC_T_CS_PROG_PATH,
  ERTS_ALC_T_HEAP,
  ERTS_ALC_T_OLD_HEAP,
  ERTS_ALC_T_HEAP_FRAG,
  ERTS_ALC_T_DB_SEG,
  ERTS_ALC_T_DB_SEG_TAB,
  ERTS_ALC_T_DB_STK,
  ERTS_ALC_T_DB_TRANS_TAB,
  ERTS_ALC_T_DB_SEL_LIST,
  ERTS_ALC_T_DB_DMC_ERROR,
  ERTS_ALC_T_DB_DMC_ERR_INFO,
  ERTS_ALC_T_DB_TERM,
  ERTS_ALC_T_PROC,
  ERTS_ALC_T_ATOM,
  ERTS_ALC_T_EXPORT,
  ERTS_ALC_T_MODULE,
  ERTS_ALC_T_REG_PROC,
  ERTS_ALC_T_MONITOR_SH,
  ERTS_ALC_T_NLINK_SH,
  ERTS_ALC_T_PROC_LIST,
  ERTS_ALC_T_FUN_ENTRY,
  ERTS_ALC_T_DB_TABLE,
  ERTS_ALC_T_DRV_EV_D_STATE,
  ERTS_ALC_T_DRV_SEL_D_STATE,
  ERTS_ALC_T_DRV_BINARY,
  ERTS_ALC_T_BINARY,
  ERTS_ALC_T_DRV,
  ERTS_ALC_T_INVALID
};

const char *erts_alc_n2td[] = {
  "invalid_type",
  "undefined",
  "nbif_tab",
  "async",
  "info_dsbuf",
  "driver_thread_opts",
  "driver_tid",
  "driver_mutex",
  "driver_cond",
  "driver_rwlock",
  "driver_tsd",
  "ethread_internal",
  "environment",
  "putenv_string",
  "msg_roots",
  "root_set",
  "loader_tmp",
  "nc_tmp",
  "tmp",
  "dctrl_buf",
  "tmp_dist_buf",
  "estack",
  "port_call_buf",
  "db_tmp",
  "db_mc_stack",
  "db_match_spec_cmpl_heap",
  "logger_dsbuf",
  "tmp_dsbuf",
  "ddll_tmp_buf",
  "sys_read_buf",
  "pending_suspend",
  "msg_ref",
  "bif_timer_sl",
  "db_fixation",
  "fixed_del",
  "db_match_spec_run_heap",
  "port_task",
  "port_task_queue",
  "misc_op_list",
  "port_names",
  "fd_list",
  "pollset_update_req",
  "link_lh",
  "monitor_lh",
  "nlink_lh",
  "suspend_monitor",
  "bif_timer_ll",
  "reg_tab",
  "fun_tab",
  "dist_tab",
  "node_tab",
  "module_refs",
  "dcache",
  "dist_entry",
  "node_entry",
  "drv_entry_list",
  "arg_reg",
  "proc_dict",
  "calls_buf",
  "bpd",
  "port_name",
  "line_buf",
  "io_queue",
  "bits_buf",
  "ddll_processes",
  "ddll_handle",
  "port_data_lock",
  "nodes_monitor",
  "fd_entry_buf",
  "port_report_exit",
  "atom_text",
  "bif_timer_table",
  "atom_tab",
  "export_tab",
  "module_tab",
  "proc_tab",
  "port_tab",
  "timer_wheel",
  "code",
  "async_queue",
  "db_tabs",
  "db_match_pseudo_proc",
  "instr_info",
  "scheduler_data",
  "ddll_errcodes",
  "drv_tab",
  "driver_event_state",
  "pollset",
  "poll_fds",
  "poll_result_events",
  "fd_status",
  "fd_tab",
  "cs_prog_path",
  "heap",
  "old_heap",
  "heap_frag",
  "db_segment",
  "db_segment_tab",
  "db_stack",
  "db_trans_tab",
  "db_select_list",
  "db_dmc_error",
  "db_dmc_error_info",
  "db_term",
  "proc",
  "atom_entry",
  "export_entry",
  "module_entry",
  "reg_proc",
  "monitor_sh",
  "nlink_sh",
  "proc_list",
  "fun_entry",
  "db_tab",
  "driver_event_data_state",
  "driver_select_data_state",
  "drv_binary",
  "binary",
  "drv_internal",
  NULL
};

const char *erts_alc_c2cd[] = {
  "invalid_class",
  "process_data",
  "ets_data",
  "binary_data",
  "atom_data",
  "system_data",
  "code_data",
  NULL
};

const char *erts_alc_a2ad[] = {
  "invalid_allocator",
  "sys_alloc",
  "temp_alloc",
  "sl_alloc",
  "std_alloc",
  "ll_alloc",
  "eheap_alloc",
  "ets_alloc",
  "fix_alloc",
  "binary_alloc",
  "driver_alloc",
  NULL
};

#endif /* #ifdef ERTS_ALC_INTERNAL__ */


/* ------------------------------------------------------------------------- */
#endif /* #ifndef ERL_ALLOC_TYPES_H__ */
